diff -uNr Mesa-5.0.1.orig/GLwrapper-0.1.8/GLwrapper.c Mesa-5.0.1/GLwrapper-0.1.8/GLwrapper.c
--- Mesa-5.0.1.orig/GLwrapper-0.1.8/GLwrapper.c	Sat Nov 29 17:09:46 2003
+++ Mesa-5.0.1/GLwrapper-0.1.8/GLwrapper.c	Sat Nov 29 19:11:50 2003
@@ -202,6 +202,7 @@
       int ignore;
       int version;
       struct display_dispatch *d;
+      unsigned int glx_adp_ind, glx_adp_fnd;
 
 
       /* get overridden libraries filename by environment variable */
@@ -231,18 +232,26 @@
 	  version = VendorRelease(dpy);
 	  if (version >= 4000) 
 	    {
-	      if (ainfo && strstr (ainfo[0].name, "NV")) 
-		{
-		  current_lib = xf4_nv_lib;
-		  alt_current_lib = NULL;
+	      glx_adp_ind = 0;
+	      glx_adp_fnd = 0;
+	      while(!glx_adp_fnd && glx_adp_ind < nadaptors)
+	        {
+	          if (ainfo && strstr (ainfo[glx_adp_ind].name, "NV")) 
+		    {
+		      current_lib = xf4_nv_lib;
+		      alt_current_lib = NULL;
+		      glx_adp_fnd = 1;
+		    } 
+	          else if (ainfo && strstr (ainfo[glx_adp_ind].name, "ATI") && 
+		           (ainfo[glx_adp_ind].base_id == 61) && !strstr (ainfo[glx_adp_ind].name, "mach"))
+		    {
+		      current_lib = xf4_fglrx_lib;
+		      alt_current_lib = NULL;
+		      glx_adp_fnd = 1;
+		    }
+		  glx_adp_ind++;    
 		} 
-	      else if (ainfo && strstr (ainfo[0].name, "ATI") && 
-		       (ainfo[0].base_id == 61) && !strstr (ainfo[0].name, "mach"))
-		{
-		  current_lib = xf4_fglrx_lib;
-		  alt_current_lib = NULL;
-		} 
-	      else 
+	      if(!glx_adp_fnd) 
 		{
 		  current_lib = xf4_glx_lib;
 		  alt_current_lib = alt_xf4_glx_lib;
